// 商品销售排名
import { connect } from "umi";
import type { CurrentUser } from "umi";
import type { ConnectState } from "@/models/connect";
import React, { useRef, useState } from "react";
import ProCard from "@ant-design/pro-card";
import { MenuFoldOutlined } from "@ant-design/icons";
import type { FormInstance } from "antd";
import { Button, message, Space, Spin, Tree, TreeSelect } from "antd";
import useRequest from "@ahooksjs/use-request";
import { getServerpartTree, handleGetServiceShopTreeList } from "@/services/options";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import ReactHTMLTableToExcel from "react-html-table-to-excel";
import { handleGetSaleRank } from "@/pages/reports/BusinessAnalysis/saleRankReport/service";
import moment from "moment/moment";
import { handleGetNestingCOMMODITYTYPETree } from "@/pages/reports/BusinessAnalysis/saleTypeReport/service";
import ProDescriptions from "@ant-design/pro-descriptions";
import numeral from "numeral";
import { contractType } from "@/pages/contract/emun";
import { handleGetShopShortNamesGet } from "@/pages/reports/BusinessAnalysis/transactionAnalysis/service";
import PageTitleBox from "@/components/PageTitleBox";
import { exportXlsxFromProColumnsExcelJS } from "@/utils/exportExcelFun";
import { formatTreeData } from "@/utils/format";
import session from "@/utils/session";


const saleRankReport: React.FC<{ currentUser: CurrentUser }> = (props) => {
  const { currentUser } = props
  const downloadBtnRef = useRef<any>()
  const actionRef = useRef<ActionType>();
  const formRef = useRef<FormInstance>();
  const [reqDetailList, setReqDetailList] = useState<any>(); // 合计项数据源
  const [printOut, setPrintOut] = useState<any>(); // 打印数据的内容
  const [collapsible, setCollapsible] = useState<boolean>(false)
  const [treeView, setTreeView] = useState<any>()
  // 加载服务区树
  const { loading: treeLoading, data: treeViews } = useRequest(async () => {
    const data = await handleGetServiceShopTreeList({
      ProvinceCode: currentUser?.ProvinceCode,
      BusinessState: "1000,2000,3000",
      ShowState: true,
      SortStr: 'BUSINESS_STATE,SHOPSHORTNAME'
    });
    setTreeView(data)
    return data
  })
  // 树相关的属性和方法
  const [selectedId, setSelectedId] = useState<string>()
  //   获取选择的门店id
  const [selectShopId, setSelectShopId] = useState<any>()
  // 导出的加载效果
  const [showLoading, setShowLoading] = useState<boolean>(false)
  // 是否显示打印的表格
  const [showExportTable, setShowExportTable] = useState<boolean>(false)

  // 商品类别
  const [commodityTypeList, setCommodityTypeList] = useState<any>()
  // 商品类别的选择值
  const [commodityTypeValue, setCommodityTypeValue] = useState<any>()
  // 表格数据
  const [tableData, setTableData] = useState<any>()

  const { loading: nestLoading, data: nestList } = useRequest(async () => {
    const req = {
      PROVINCE_CODE: currentUser?.ProvinceCode,
      ShowCode: true
    }
    const data = await handleGetNestingCOMMODITYTYPETree(req)
    console.log('data2', data)
    setCommodityTypeList(data)
  })
  const BUSINESSTYPEObj = session.get('BUSINESSTYPEObj')
  // 自营业态的选择列表
  const [shopNamesList, setShopNamesList] = useState<any>()
  // 自营业态的选择的列表方法
  const handleGetShopNamesList = async (id: any) => {
    if (id) {
      const req: any = {
        ProvinceCode: currentUser?.ProvinceCode,
        BusinessType: 1000,
        ServerpartId: id || selectedId
      }
      const data = await handleGetShopShortNamesGet(req)
      console.log('data', data)
      if (data && data.length > 0) {
        const obj: any = {}
        if (data && data.length > 0) {
          data.forEach((item: any) => {
            obj[item] = item
          })
        }
        setShopNamesList(obj)
      }
    } else {
      setShopNamesList([])
    }
  }
  const columns: any = [
    {
      title: '统计时间',
      dataIndex: 'search_date',
      valueType: 'dateRange',
      hideInTable: true,
      hideInDescriptions: true,
      colSize: 1,
      initialValue: [moment().add(-10, 'day').format('YYYY-MM-DD'), moment().add(-1, 'day').format('YYYY-MM-DD')],
      search: {
        transform: (value) => {
          return {
            startDate: value[0],
            endDate: value[1],
          };
        },
      },
      fieldProps: {
        disabledDate: (current: any) => current && current > moment()
      }
    },
    {
      title: '商品类别',
      dataIndex: 'commodityType',
      hideInTable: true,
      renderFormItem: () => {
        return <TreeSelect
          treeData={commodityTypeList}
          allowClear
          treeCheckable
          onChange={(e: any) => {
            if (e) {
              setCommodityTypeValue(e.toString())
            } else {
              setCommodityTypeValue(undefined)
            }
          }}
        />
      }
    },
    {
      title: '筛选排名',
      dataIndex: 'top',
      hideInTable: true,
      valueType: 'digit',
      initialValue: '20'
    },
    {
      title: '经营模式',
      key: 'BusinessType',
      dataIndex: 'BusinessType',
      valueType: 'select',
      // valueEnum: contractType,
      valueEnum: BUSINESSTYPEObj,
      hideInTable: true,
    },
    {
      title: '自营业态',
      dataIndex: 'shopNames',
      hideInTable: true,
      valueType: 'select',
      valueEnum: shopNamesList,
      // request: async () => {
      //   return await getFieldEnum({ FieldExplainField: 'BUSINESSTYPE' })
      // },
      fieldProps: {
        multiple: true,
        showSearch: true,
        filterOption: (input, option) => (option?.label ?? '').toLowerCase().includes(input.toLowerCase()),
      }
    },
    {
      title: '序号',
      width: 80,
      dataIndex: 'index',
      valueType: 'index',
      align: 'center',
      hideInSearch: true
    },
    {
      title: '商品类别',
      width: 120,
      align: 'center',
      ellipsis: true,
      dataIndex: 'Commodity_TypeName',
      hideInSearch: true
    },
    {
      title: <div style={{ textAlign: 'center' }}>商品名称</div>,
      width: 250,
      ellipsis: true,
      align: 'left',
      dataIndex: 'Commodity_Name',
      hideInSearch: true
    },
    {
      title: '商品条码',
      width: 120,
      align: 'center',
      dataIndex: 'Commodity_Barcode',
      hideInSearch: true
    },
    {
      title: '商品单位',
      width: 120,
      align: 'center',
      dataIndex: 'Commodity_Unit',
      hideInSearch: true
    },
    {
      title: '商品规格',
      width: 120,
      align: 'center',
      dataIndex: 'Commodity_Rule',
      hideInSearch: true
    },
    {
      title: <div style={{ textAlign: 'center' }}>销售单价</div>,
      width: 120,
      align: 'right',
      valueType: "digit",
      dataIndex: 'Commodity_RetailPrice',
      hideInSearch: true
    },
    {
      title: <div style={{ textAlign: 'center' }}>销售数量</div>,
      width: 120,
      align: 'right',
      valueType: "digit",
      dataIndex: 'Total_Count',
      hideInSearch: true
    },
    {
      title: <div style={{ textAlign: 'center' }}>销售金额</div>,
      width: 120,
      align: 'right',
      valueType: "digit",
      dataIndex: 'Total_SellAmount',
      hideInSearch: true
    },
  ]

  const exportTable = (e) => {
    e.stopPropagation();                                            // 防止Collapse组件收起
    const main = document.getElementsByClassName('saleReportHideBox')[0]
    const thead = main.querySelector('thead').cloneNode(true);  // 深克隆DOM节点
    const tbody = main.querySelector('tbody').cloneNode(true);  // 深克隆DOM节点
    const container = document.querySelector('#hiddenBox');

    const tempTable = document.createElement('table');
    tempTable.appendChild(thead);
    tempTable.appendChild(tbody);

    tempTable.setAttribute('id', 'table-to-xls-saleRankReport');                    // 给table添加id，值与按钮上的table字段对应

    container.appendChild(tempTable);                                // 把创建的节点添加到页面容器中

    setShowLoading(false)

    downloadBtnRef.current.handleDownload();
    setShowExportTable(false)
    tempTable.remove() // 防止重复打印一个内容
  }
  // 查询的条件
  const [searchParams, setSearchParams] = useState<any>()

  return (
    <div ref={(el) => {
      // 打印报表
      if (!reqDetailList || reqDetailList.length === 0) return;
      setPrintOut(el);
    }} >

      {
        showLoading ?
          <div
            style={{
              width: '100%',
              height: '100%',
              background: 'rgba(0,0,0,0.1)',
              position: 'fixed',
              zIndex: 5,
              display: 'flex',
              alignItems: 'center',
              justifyContent: 'center'
            }}
          >
            <div style={{
              display: 'flex',
              alignItems: 'center',
              justifyContent: 'center',
              padding: '15px 20px 10px',
              background: '#fff',
              borderRadius: '8px',
              width: '200px'
            }}>
              <Spin />
              <span style={{ marginLeft: '5px' }}>数据导出中...</span>
            </div>
          </div> : ''
      }

      <div className={'saleReportHideBox'} style={{ position: 'fixed', zIndex: -1, top: 0, left: 0 }}>
        {
          showExportTable && reqDetailList && reqDetailList.length > 0 ?
            <ProTable
              columns={columns}
              dataSource={reqDetailList}
              pagination={false}
              expandable={{
                defaultExpandAllRows: true
              }}
            /> : ''
        }
      </div>
      <div id='hiddenBox' style={{ position: 'fixed', zIndex: -1, top: 0, left: 0 }} />

      <div style={{ backgroundColor: '#fff', display: 'flex' }}>
        <ProCard
          style={{ width: !collapsible ? "300px" : "60px" }}
          className="pageTable-leftnav"
          bodyStyle={{ padding: 0, paddingTop: 20, paddingLeft: 20, width: !collapsible ? "300px" : "60px" }}
          extra={<MenuFoldOutlined onClick={() => {
            setCollapsible(!collapsible)
          }} />}
          colSpan={!collapsible ? "300px" : "60px"}
          title={!collapsible ? "请选择服务区" : ""}
          headerBordered
          collapsed={collapsible}
        >
          {treeView && treeView.length > 0 ? <Tree
            checkable
            treeData={[{
              label: '全部',
              value: 0,
              key: '0-0',
              children: treeView
            }]}
            fieldNames={{
              title: "label",
              key: "key"
            }}
            blockNode
            defaultExpandedKeys={['0-0']}
            onCheck={(checkedKeys: React.Key[] | any, info) => {
              console.log('info', info)
              // const selectedIds = info.checkedNodes.filter(n => n?.type === 1)
              const selectShopId = info.checkedNodes.filter(n => n?.type === 2)

              // setSelectedId(selectedIds.map(n => n?.value)?.toString() || '')
              setSelectShopId(selectShopId.map(n => n?.value)?.toString() || '')
              // 根据选的门店 找出他的服务区
              let serverpartId: any = []
              if (selectShopId && selectShopId.length > 0) {
                selectShopId.forEach((item: any) => {
                  treeView.forEach((subItem: any) => {
                    if (subItem.children && subItem.children.length > 0) {
                      subItem.children.forEach((thirdItem: any) => {
                        if (thirdItem.children && thirdItem.children.length > 0) {
                          thirdItem.children.forEach((fourthItem: any) => {
                            if (item.value === fourthItem.value) {
                              serverpartId.push(thirdItem.value)
                            }
                          })
                        }
                      })
                    }
                  })
                })
              }

              // handleGetShopNamesList(selectShopId.map(n => n?.value)?.toString() || '')
              handleGetShopNamesList(serverpartId.toString() || '')
              // actionRef?.current?.reload()
              // getData(selectedIds.map(n => n?.value)?.toString() || '')
            }}
          // switcherIcon={<PlusOutlined />}
          /> : ''}
        </ProCard>
        <div style={{
          width: !collapsible ? 'calc(100% - 300px)' : 'calc(100% - 60px)',
          paddingTop: 0,
          paddingBottom: 0,
          paddingRight: 0
        }}>
          <ProTable
            actionRef={actionRef}
            formRef={formRef}
            columns={columns}
            bordered
            headerTitle={<PageTitleBox props={props} />}
            search={{ span: 6, defaultCollapsed: false }}
            scroll={{ x: "100%", y: 'calc(100vh - 480px)' }}
            pagination={false}
            request={async (params) => {
              if (!selectShopId) {
                return
              }
              const req = {
                ...params,
                // ServerpartIds: selectedId,
                commodityType: commodityTypeValue,
                ServerpartShopIds: selectShopId
              }
              setSearchParams(params)
              console.log('req', req)
              const data = await handleGetSaleRank(req)
              console.log('data', data)
              if (data && data.length > 0) {
                let fieldData: any = [
                  "Total_Count",
                  "Total_SellAmount",
                ]
                let enumList: any = []
                let newPrintData: any = formatTreeData(JSON.parse(JSON.stringify(data)), fieldData, enumList, [], [])
                setReqDetailList(newPrintData)
                setTableData(data)
                return { data, success: true }
              }
              setReqDetailList([])
              setTableData([])
              return { data: [], success: true }
            }}
            toolbar={{
              actions: [
                // <span style={{ visibility: 'hidden' }}>
                //   <ReactHTMLTableToExcel
                //     buttonText={'导出excel'}
                //     ref={downloadBtnRef}
                //     table="table-to-xls-saleRankReport"
                //     filename={`单品销售排行统计${searchParams?.startDate}-${searchParams?.endDate}`}
                //     sheet="sheet1"
                //   />
                // </span>,
                <Button
                  key="new"
                  type="primary"
                  onClick={(e) => {
                    if (reqDetailList && reqDetailList.length > 0) {
                      // 尝试一下 导出新方法 
                      exportXlsxFromProColumnsExcelJS(columns,
                        reqDetailList,
                        `商品销售排名${searchParams?.startDate}-${searchParams?.endDate}`,
                        {
                          // topTitle: `单品销售排行统计`, // 顶部大标题
                          footerMaker: currentUser?.Name,
                          footerMakerTime: moment().format('YYYY-MM-DD HH:mm:ss'),
                          footerStatsTime: `${searchParams?.startDate}-${searchParams?.endDate}`
                        }
                      )
                    } else {
                      message.error('暂无数据可导出！')
                    }


                    // if (reqDetailList && reqDetailList.length > 0) {
                    //   setShowLoading(true)
                    //   setTimeout(() => {
                    //     setShowExportTable(true)
                    //     setTimeout(() => {
                    //       exportTable(e)
                    //     }, 100)
                    //   }, 100)
                    // } else {
                    //   message.error('暂无数据可导出！')
                    // }
                  }}
                >
                  导出excel
                </Button>
              ]
            }}
            tableExtraRender={() => {
              if (tableData && tableData.length > 0) {
                let Total_CountSum: number = 0
                let Total_SellAmountSum: number = 0

                tableData.forEach((item: any) => {
                  Total_CountSum += item.Total_Count
                  Total_SellAmountSum += item.Total_SellAmount
                })
                return <div style={{ paddingLeft: 30, paddingBottom: 0 }}>
                  <ProDescriptions column={4} className="commity-sale-description" labelStyle={{ color: "#00000073" }}>
                    <ProDescriptions.Item label="销售数量" contentStyle={{ color: 'orangered' }}>{Total_CountSum ? numeral(Total_CountSum).format('0,0.00') : '0'}</ProDescriptions.Item>
                    <ProDescriptions.Item label="销售金额" valueType="money" contentStyle={{ color: 'orangered' }}>{Total_SellAmountSum || '0.00'}</ProDescriptions.Item>
                    <ProDescriptions.Item label="统计时间">{`${moment(searchParams?.startDate).format('YYYY-MM-DD')}-${moment(searchParams?.endDate).format('YYYY-MM-DD')}`}</ProDescriptions.Item>
                  </ProDescriptions>
                </div>
              }
            }}
          />
        </div>
      </div>
    </div>
  )
}

export default connect(({ user }: ConnectState) => ({
  currentUser: user.currentUser
}))(saleRankReport);
